﻿#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <chrono>
#include <set>
#include <map>

using namespace std;

using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;

template<typename T,typename G>
using pl = pair<T, G>;


template<typename T, typename G>
istream& operator>>(istream& in, pl<T, G>& a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T,typename G>
ostream& operator<<(ostream& out, pair<T,G>& a) {
    out << a.first << ' ' << a.second;
    out << '\n';
    return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T> &a) {
    for (auto& x : a)in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vl<T>& a) {
    for (auto& x : a)out << x << ' '; 
    out << '\n';
    return out;
}


void solve() {
    i64 n, m;
    cin >> n >> m;
    vl<vl<i64>> s1(n);
    i64 now = 0;
    for (i64 i = 0; i < n; i++) {
        s1[i].resize(6, 1);
    }

    for (i64 i = 0; i < n; i++) {
        char a;
        for (i64 j = 0; j < 6; j++) {
            cin >> a;
            s1[i][j] = 1;
            now++;
            if (a == '.') { s1[i][j] = 0; now--; }
        }
    }
    i64 cnt_need = 0;
    for (i64 i = 0; i < n; i++) {
        for (i64 j = 0; j < 3; j++) {
            if (s1[i][j] != s1[i][5 - j])cnt_need++;
        }
    }
    if ((now + m) % 2 != 0 || m < cnt_need) { cout << "Impossible"; return; }
    for (i64 i = 0; i < n; i++) {
        for (i64 j = 0; j < 6; j++) {
            if (s1[i][j] == 1 && s1[i][5 - j] != 1) { s1[i][5 - j] = 1; m--; }
            if (s1[i][5 - j] == 1 && s1[i][j] != 1) { s1[i][j] = 0; m--; }
        }
    }
    for (i64 i = 0; i < n; i++) {
        for (i64 j = 0; j < 6; j++) {
            if (m > 0 && s1[i][j] == 0 && s1[i][j-1] == 0) {
                s1[i][j] = 1;
                s1[i][5 - j] = 1;
                m -= 2;
            }
        }
    }
    for (i64 i = 0; i < n; i++) {
        for (i64 j = 0; j < 6; j++) {
            cout << (s1[i][j] ? 'X' : '.');
        }
        cout << '\n';
    }

}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    i64 t = 1;
    //cin>>t;
    while (t--) { solve(); }
}