﻿#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <chrono>
#include <set>
#include <map>

using namespace std;

using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;

template<typename T, typename G>
using pl = pair<T, G>;


template<typename T, typename G>
istream& operator>>(istream& in, pl<T, G>& a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename G>
ostream& operator<<(ostream& out, pair<T, G>& a) {
    out << a.first << ' ' << a.second;
    out << '\n';
    return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T>& a) {
    for (auto& x : a)in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vl<T>& a) {
    for (auto& x : a)out << x << ' ';
    out << '\n';
    return out;
}

vl<vl<int>> g;
vl<bool> used;
vl<int> wht;
int n, k, t;

void dfs2(int v,int k) {
    used[v] = true;
    if (v == k) { wht[v] = 0; }
    for (auto to : g[v]) {
        if (used[v])continue;
        wht[to] = wht[v] + 1;
        dfs2(to, k);
    }
}

void solve() {
    cin >> n >> k >> t;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    wht.resize(n, 0);
    used.resize(n, 0);
    i64 ans = 1e9;
    for (int i = 0; i < n; i++) {
        dfs2(0, i);
        i64 q;
        for (int i = 0; i < n; i++) { q = max(q, (i64)wht[i]); }
        ans = min(q, ans);

    }
    cout << ans;

}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    i64 t = 1;
    //cin>>t;
    while (t--) { solve(); }
}