﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <chrono>
#include <random>
using namespace std;


using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;


template<typename T,typename G>
using pl = pair<T,G>;


template<typename T>
ostream& operator<<(ostream& out,vl<T> a) {
	for (auto x : a) out << x << ' ';
	out << '\n';
	return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T>& a) {
	for (auto &x : a) in >> x;
	return in;
}


vl<pl<i64, i64>> s1;
vl<vl<int>> g(1e6);

vl<int> used;
int val;
void dfs(int v,int color) {
	used[v] = color;
	for (auto to: g[v]){
		if (used[to] == -1)dfs(to, 1 - color);
	}
}

void solve() {
	i64 n;
	cin >> n;
	vl<i64> is_prime(1e6 + 1, 1);
	vl<i64> last(is_prime.size(), -1);
	is_prime[0] = 0;
	is_prime[1] = 0;
	last[0] = 1;
	last[1] = 1;
	s1.resize(n);
	for (int i = 0; i < n; i++) { cin >> s1[i].first; s1[i].second = i; }
	for (i64 i = 2; i < is_prime.size(); i++) {
		if (!is_prime[i])continue;
		for (i64 j = i * i; j < is_prime.size(); j += i) {
			if (is_prime[j]) {
				is_prime[j] = 0;
				last[j] = i;
			}
		}
		last[i] = i;
	}
	set<i64> di;
	used.resize(1e6 + 1, -1);
	for (int i = 0; i < n; i++) { di.insert(s1[i].first); }
	for (int i = 0; i < n; i++) {
		int index = s1[i].first;
		//cout << s1[i].first << '\n';
		while (index != 1) {
			//cout << s1[i].first / last[index] << ' ';
			if (di.find(s1[i].first / last[index]) != di.end()) {
				g[s1[i].first].push_back(s1[i].first / last[index]);
				g[s1[i].first / last[index]].push_back(s1[i].first);
			}
			index = index / last[index];
			//cout << "---------\n";
		}
		//cout << "----------------------------\n";
	}
	for (int i = 0; i < n; i++) {
		//cout << s1[i].first << ' ' << g[s1[i].first] << '\n';
		if (used[s1[i].first] == -1) { dfs(s1[i].first, 0); }
	}
	for (int i = 0; i < n; i++) {
		cout << used[s1[i].first] + 1 << ' ';
	}


}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	i64 t = 1;
	while (t--) {
		solve();
	}
	
}
