﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <chrono>
#include <random>
//#pragma GCC optimize('no-stack-protector')
using namespace std;



using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;


template<typename T,typename G>
using pl = pair<T,G>;


template<typename T>
ostream& operator<<(ostream& out,vl<T> a) {
	for (auto x : a) out << x << ' ';
	out << '\n';
	return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T>& a) {
	for (auto &x : a) in >> x;
	return in;
}
int n, q;
vl<pl<int, int>> g;
vl<int> a;
vl<int> tree;
vl<int> lazy;
int tree_size = 0;
int inf = 1e9;
int root;
vl<int> dp;
int timer;
bool changed =false;


void build_tree() {
	tree_size = (1 << int(ceil(log2(n))));
	tree.resize(tree_size * 2, inf);
	lazy.resize(tree_size * 2, inf);
	for (int i = 0; i < n; i++) {
		tree[tree_size + i] = -1;
	}
}

void prop(int v) {
	if (lazy[v] == inf)return; 
	tree[v * 2] = lazy[v];
	tree[v * 2 + 1] = lazy[v];
	lazy[v * 2] = lazy[v];
	lazy[v * 2 + 1] = lazy[v];
	lazy[v] = inf;
}

void set_tree(int l,int r,int ql,int qr, int v,int x) {
	if (l >= qr || ql >= r)return;
	if (l >= ql && qr >= r) {
		lazy[v] = x;
		tree[v] = x;
		return;
	}
	int mid = (l + r) / 2;
	prop(v);
	set_tree(l, mid, ql, qr, v * 2, x);
	set_tree(mid, r, ql, qr, v * 2 + 1, x);
}

void get_mass() {
	for (int i = 1; i < tree_size; i++) {
		if (lazy[i] != inf)prop(i);
	}
	for (int i = 0; i < n; i++) {
		a[i] = tree[i + tree_size];
	}
}

void get_dfs(int v) {
	int lc = g[v].first;
	int rc = g[v].second;

	if (a[v] == -1) {
		dp[v] = timer;
		timer++;
		if (lc != -1)get_dfs(lc);
		if (rc != -1)get_dfs(rc);
	}
	if (a[v] == 0) {
		if (lc != -1)get_dfs(lc);
		dp[v] = timer;
		timer++;
		if (rc != -1)get_dfs(rc);
	}
	if (a[v] == 1) {
		if (lc != -1)get_dfs(lc);
		if (rc != -1)get_dfs(rc);
		dp[v] = timer;
		timer++;
	}
}

void get_ans() {
	timer = 1;
	if (changed) {
		get_mass();
		get_dfs(root);
	}
}



void solve() {
	cin >> n >> q;
	g.resize(n);
	a.resize(n, -1);
	dp.resize(n);
	vl<int> was(n);
	for (int i = 0; i < n; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[i].first = a;
		g[i].second = b;
		if (a != -1)was[a] = 1;
		if (b != -1)was[b] = 1;
	}
	for (int i = 0; i < n; i++) {
		if (!was[i])root = i;
	}
	changed = true;

	build_tree();
	get_ans();
	changed = false;
	for (int i = 0; i < q; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			int l, r, x;
			cin >> l >> r >> x;
			l--;
			set_tree(0, tree_size, l, r, 1, x);
			changed = true;
		}
		if (type == 2) {
			int u;
			cin >> u;
			u--;
			get_ans();
			cout << dp[u] << '\n';
			changed = false;
		}
	}


}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	i64 t = 1;
	while (t--) {
		solve();
	}
	
}
